<?php

////////////////////////////////////////////////////////////////////////////////
// WP-PageNavi
////////////////////////////////////////////////////////////////////////////////


function custom_wp_pagenavi($before = '', $after = '', $prelabel = '', $nxtlabel = '', $pages_to_show = 5, $always_show = false) {
	global $request, $posts_per_page, $wpdb, $paged;
	if(empty($prelabel)) {
		$prelabel  = '<strong>&laquo;</strong>';
	}
	if(empty($nxtlabel)) {
		$nxtlabel = '<strong>&raquo;</strong>';
	}
	$half_pages_to_show = round($pages_to_show/2);
	if (!is_single()) {
		if(!is_category()) {
			preg_match('#FROM\s(.*)\sORDER BY#siU', $request, $matches);
		} else {
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);
		}
		$fromwhere = $matches[1];
		$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
		$max_page = ceil($numposts /$posts_per_page);
		if(empty($paged)) {
			$paged = 1;
		}
		if($max_page > 1 || $always_show) {
			echo "$before <div class=\"wp-pagenavi\"><span class=\"pages\">Page $paged of $max_page:</span>";
			if ($paged >= ($pages_to_show-1)) {
				echo '<a href="'.get_pagenum_link().'">&laquo; First</a>&nbsp;';
			}
			previous_posts_link($prelabel);
			for($i = $paged - $half_pages_to_show; $i  <= $paged + $half_pages_to_show; $i++) {
				if ($i >= 1 && $i <= $max_page) {
					if($i == $paged) {
						echo "<strong class='current'>$i</strong>";
					} else {
						echo ' <a href="'.get_pagenum_link($i).'">'.$i.'</a> ';
					}
				}
			}
			next_posts_link($nxtlabel, $max_page);
			if (($paged+$half_pages_to_show) < ($max_page)) {
				echo '&nbsp;<a href="'.get_pagenum_link($max_page).'">Last &raquo;</a>';
			}
			echo "</div> $after";
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
// Comment And Ping Setup
////////////////////////////////////////////////////////////////////////////////

function list_pings($comment, $args, $depth) {
$GLOBALS['comment'] = $comment; ?>
<li id="comment-<?php comment_ID(); ?>"><?php comment_author_link(); ?>
<?php }

add_filter('get_comments_number', 'comment_count', 0);

function comment_count( $count ) {
	global $id;
	$comments_by_type = &separate_comments(get_comments('post_id=' . $id));
	return count($comments_by_type['comment']);
}


////////////////////////////////////////////////////////////////////////////////
// Comment and pingback separate controls
////////////////////////////////////////////////////////////////////////////////

$bm_trackbacks = array();
$bm_comments = array();

function split_comments( $source ) {

if ( $source ) foreach ( $source as $comment ) {

global $bm_trackbacks;
global $bm_comments;

if ( $comment->comment_type == 'trackback' || $comment->comment_type == 'pingback' ) {
$bm_trackbacks[] = $comment;
} else {
$bm_comments[] = $comment;
}
}
}
////////////////////////////////////////////////////////////////////////////////
// Get Recent Comments With Avatar
////////////////////////////////////////////////////////////////////////////////
function get_avatar_recent_comment() {

global $wpdb;

$sql = "SELECT DISTINCT ID, post_title, post_password, comment_ID,
comment_post_ID, comment_author, comment_author_email, comment_date_gmt, comment_approved,
comment_type,comment_author_url,
SUBSTRING(comment_content,1,45) AS com_excerpt
FROM $wpdb->comments
LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID =
$wpdb->posts.ID)
WHERE comment_approved = '1' AND comment_type = '' AND
post_password = ''
ORDER BY comment_date_gmt DESC LIMIT 5";

$comments = $wpdb->get_results($sql);
$output = $pre_HTML;
$gravatar_status = 'on'; /* off if not using */

foreach ($comments as $comment) {

$email = $comment->comment_author_email;
$grav_name = $comment->comment_author_name;
$grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5($email). "&amp;size=35";

?>
<li>
<?php if($gravatar_status == 'on') { ?>
<img class="alignleft" src="<?php echo $grav_url; ?>" alt="<?php echo $grav_namel ?>" />
<?php } ?>
<?php echo strip_tags($comment->comment_author); ?>: <br />
<a href="<?php echo get_permalink($comment->ID); ?>#comment-<?php echo $comment->comment_ID; ?>" title="on <?php echo $comment->post_title; ?>">
<?php echo strip_tags($comment->com_excerpt); ?>...
</a>
</li>
<?php
}
}
////////////////////////////////////////////////////////////////////////////////

// Hot Topics

////////////////////////////////////////////////////////////////////////////////

function get_hottopics($limit = 5) {

    global $wpdb, $post;

    $mostcommenteds = $wpdb->get_results("SELECT  $wpdb->posts.ID, post_title, post_name, post_date, COUNT($wpdb->comments.comment_post_ID) AS 'comment_total' FROM $wpdb->posts LEFT JOIN $wpdb->comments ON $wpdb->posts.ID = $wpdb->comments.comment_post_ID WHERE comment_approved = '1' AND post_date_gmt < '".gmdate("Y-m-d H:i:s")."' AND post_status = 'publish' AND post_password = '' GROUP BY $wpdb->comments.comment_post_ID ORDER  BY comment_total DESC LIMIT $limit");

    foreach ($mostcommenteds as $post) {

			$post_title = htmlspecialchars(stripslashes($post->post_title));

			$comment_total = (int) $post->comment_total;

			echo "<li><a href=\"".get_permalink()."\">$post_title</a><br /> <span class=\"total-com\">Всего комментариев - $comment_total </span></li>";

    }

}

////////////////////////////////////////////////////////////////////////////////

// Sidebar Widget

////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////

// Theme Option

////////////////////////////////////////////////////////////////////////////////


$themename = "Bluevibes";
$shortname = "rk";

$wp_dropdown_rd_admin = $wpdb->get_results("SELECT $wpdb->term_taxonomy.term_id,name,description,count FROM $wpdb->term_taxonomy LEFT JOIN $wpdb->terms ON $wpdb->term_taxonomy.term_id = $wpdb->terms.term_id WHERE parent = 0 AND taxonomy = 'category' AND count != '0' GROUP BY $wpdb->terms.name ORDER by $wpdb->terms.name ASC");
$wp_getcat = array();
foreach ($wp_dropdown_rd_admin as $category_list) {
$wp_getcat[$category_list->term_id] = $category_list->name;
}
$category_bulk_list = array_unshift($wp_getcat, "Выберите рубрику:");


$options = array (

   
    array(	"name" => "Настройки Google Adsense и Analytics",
            "type" => "heading",
            ),

    		array(	"name" => "Включить Google Adsense в записях<br /><em>*по умолчанию отключено, но вы можете включить его</em>",
			"id" => $shortname."_adsense_loop_activate",
            "type" => "select",
            "std" => "Отключить",
			"options" => array("Отключить", "Включить")),

			array(	"name" => "Вставьте код Google Adsense здесь<br />
			<em>*Скопируйте и вставьте код Google или другой баннерной сети здесь</em>",
			"id" => $shortname."_adsense_loop",
            "type" => "textarea",
            "std" => "",
            ),

   			array(	"name" => "Включить код Google Adsense на странице<br /><em>*по умолчанию отключено, но вы можете включить его</em>",
			"id" => $shortname."_adsense_single_activate",
            "type" => "select",
            "std" => "Отключить",
			"options" => array("Отключить", "Включить")),

			array(	"name" => "Вставьте код Google Adsense для отображения на страницах здесь<br /><em>*Скопируйте и вставьте код Google или другой баннерной сети здесь</em>",
			"id" => $shortname."_adsense_single",
            "type" => "textarea",
            "std" => "",
            ),


    		array(	"name" => "Вставьте код Google Analytics <br /><em>*опционально - оставьте пустым, если не хотите использовать</em>",
			"id" => $shortname."_google_analytics",
            "type" => "textarea",
            "std" => "",
            ),

     		array(	"name" => "</div></div>",
            "type" => "close",
            ),
			

    array(  "name" => "Настройки социальных записей",
            "type" => "heading",
         	),
			
			array(	"name" => "Вставьте ID Feedburner <br /><em>*оставьте пустым если отсутствует</em>
			<br /><em>*Зарегистрироваться в Feedburner бесплатно <a href=\"http://feedburner.google.com\" target=\"_blank\">здесь</a>, если у вас нет аккаунта</em>",
			"id" => $shortname."_bluevibes_rssfeed",
            "type" => "text",
            "box" => "social",
            "std" => "",
            ),
			
			array(	"name" => "Вставьте ваш Twitter ID здесь
			<br /><em>*оставьте пустым, если не хотите отображать</em>
			<br /><em>*Зарегистрируйтесь в Twitter бесплатно <a href=\"http://www.twitter.com\" target=\"_blank\">здесь</a>, если у вас еще нет аккаунта</em>",
			"id" => $shortname."_twitter",
            "type" => "text",
            "box" => "social",
            "std" => "",
            ),

			array(	"name" => "Вставить код кнопки ShareThis 
			<br /><em>*при необходимости оставьте пустым</em>
			<br /><em>*Зарегистрироваться в ShareThis и получить кнопку можно <a href=\"http://sharethis.com/users/register/\" target=\"_blank\">здесь</a>, если у вас нет аккаунта</em>",
			"id" => $shortname."_bluevibes_sharethis",
            "type" => "textarea",
            "std" => "",
            ),
			
			array(	"name" => "</div></div>",
            "type" => "close",
            ),
			
    		array(  "name" => "Популярное видео в сайдбаре",
            "type" => "heading",
         	),
		 
		 	array(	"name" => "Вставьте код видео <br /><em>*Вы можете найти код на сайтах, которые размещают видео.</em>
			<br /><em>*i.e. Youtube - http://www.youtube.com/v/NG2zyeVRcbs</em>",
        	"id" => $shortname."_bluevibes_emvideo",
        	"std" => "",
        	"type" => "textarea"),
			
			array(	"name" => "</div></div>",
            "type" => "close",
            ),

);




function bluevibes_admin_panel() {

echo "<div id=\"admin-options\"> ";

global $themename, $shortname, $options;
if ( $_REQUEST['saved'] ) echo '<div id="update-option" class="updated fade"><strong>Настройки темы '.$themename.' сохранены.</strong></div>';
if ( $_REQUEST['reset'] ) echo '<div id="update-option" class="updated fade"><strong>Настройки темы '.$themename.' сброшены.</strong></div>';
?>


<h4>Настройки темы <?php echo "$themename"; ?></h4>


<form action="" method="post">



<?php foreach ($options as $value) { ?>

<?php
switch ( $value['type'] ) {
case 'heading':
?>
<div class="get-option">
<h2><?php echo $value['name']; ?></h2>
<div class="option-save">


<?php
break;
case 'text':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><input name="<?php echo $value['id']; ?>" class="myfield" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></p>


<?php
break;
case 'select':
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><select name="<?php echo $value['id']; ?>" class="myselect" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
<option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
<?php } ?>
</select>
</p>

<?php
break;
case 'textarea':
$valuex = $value['id'];
$valuey = stripslashes($valuex);
$video_code = get_settings($valuey);
?>

<div class="description"><?php echo $value['name']; ?></div>
<p><textarea name="<?php echo $valuey; ?>" class="mytext" cols="40%" rows="8" /><?php if ( get_settings($valuey) != "") { echo stripslashes($video_code); } else { echo $value['std']; } ?></textarea></p>

<?php
break;
case 'close':
?>

</div><div class="clearfix"></div></div>

<?php
break;
default;
?>

<?php
break; } ?>





<?php } ?>






<p class="save-p">
<input name="save" type="submit" class="sbutton" value="Сохранить" />
<input type="hidden" name="action" value="save" />
</p>
</form>

<form method="post">
<p class="save-p">
<input name="reset" type="submit" class="sbutton" value="Сбросить" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

</div>

<?php
}


function bluevibes_admin_register() {
global $themename, $shortname, $options;
if ( $_GET['page'] == basename(__FILE__) ) {
if ( 'save' == $_REQUEST['action'] ) {
foreach ($options as $value) {
update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
foreach ($options as $value) {
if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
header("Location: themes.php?page=functions.php&saved=true");
die;
} else if( 'reset' == $_REQUEST['action'] ) {
foreach ($options as $value) {
delete_option( $value['id'] ); }
header("Location: themes.php?page=functions.php&reset=true");
die;
}
}
add_theme_page($themename." настройки", "Настройки темы", 'edit_themes', basename(__FILE__), 'mytheme_admin_panel');
}

function bluevibes_admin_head() { ?>
<link href="<?php bloginfo('template_directory'); ?>/admin-css.css" rel="stylesheet" type="text/css" />
<?php }

add_action('admin_head', 'bluevibes_admin_head');
add_action('admin_menu', 'bluevibes_admin_register');

?>